package be.AM4DP;

import be.ASPL.presentationlayer.*;
import be.SIRAPRISE.client.*;
import be.SIRAPRISE.client.jsba.DmlCommand;
import be.SIRAPRISE.messages.ErrorMessageException;
import be.SIRAPRISE.util.DDLCapture;

/**
 * Function to create a job.
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = JobsCreatePresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = true, descriptionLocalizationKey = "JobsCreate.Text")
public class JobsCreate extends JobsWebClientFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		
		try (DBConnection dbc = getDBConnection();) {
			DmlCommand.execDmlCommandAndEndTransaction(dbc.startTransaction(getUserData().getUserID(), true, "", new byte[] {}, DDLCapture.OFF), new Job(((StringValue) getPresentationValue(NM_JOB)).getString().trim()).dbAddCommand()); //$NON-NLS-1$
		} catch (ConnectionClosedException e) {
			log(e);
			throw new DBProblem(e);
		} catch (ErrorMessageException e) {
			log(e);
			throw getASPLApplicationException(e);
		}
	}
}