/*
 * Created on 18-sep-2007
 */
package be.ASPL.presentationlayer;

/**
 * The HelpButton valuegetter checks whether a HELP presentation is available for the current function, and returns a html <INPUT> tag or an empty string accordingly.
 * 
 * @author Erwin Smout
 */
class ArchitectureValueGetterForHelpButton extends ArchitectureValueGetter {

	/**
	 * The instance
	 */
	private static ArchitectureValueGetter instance = new ArchitectureValueGetterForHelpButton();

	/**
	 * Gets The instance
	 * 
	 * @return The instance
	 */
	static ArchitectureValueGetter getInstance ( ) {
		return instance;
	}

	/**
	 * 
	 */
	private ArchitectureValueGetterForHelpButton ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.erwinsmout.ASPL.presentationlayer.ArchitectureValueGetter#getValue(be.erwinsmout.ASPL.presentationlayer.OnLinePresentationFunction)
	 */
	String getValue (OnLinePresentationFunction userFunction) {
		return userFunction.hasHelpPresentation() ? "<input type=\"submit\" name=\"Action\" value=\"Help\" tabindex=\"30003\"></input>" : ""; //$NON-NLS-1$ //$NON-NLS-2$
	}
}
