/*
 * Created on 10-sep-2007
 */
package be.ASPL.presentationlayer;

/**
 * The exception thrown when the Architecture fails to create a PresentationType instance for a presentation attribute
 * 
 * @author Erwin Smout
 */
class FailedToCreatePresentationTypeException extends ASPLException {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4083803788245186110L;

	/**
	 * Creates the exception and sets the display message
	 * 
	 * @param e
	 *            The exception that caused the failure
	 * @param typeName
	 *            The name of the presentation type that could not be instantiated
	 */
	FailedToCreatePresentationTypeException (Exception e, String typeName) {
		super(I18N.getInstance(), "FailedToCreatePresentationTypeException.Text", new String[] { typeName, e.getMessage(), e.getClass().getName() }); //$NON-NLS-1$
	}
}
