/**
 * 
 */
package be.ASPL.presentationlayer;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * @author Erwin
 * 
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Inherited
public @interface HelpPresentation {

	/**
	 * The name of the help presentation to be shown by an {@link OnLinePresentationFunction} when its 'help' button is pressed by the user.<br>
	 * Classes named in an annotation of this kind must have a public constructor that takes a java Locale as an argument.
	 * 
	 * @return The name of the help presentation to be shown by an {@link OnLinePresentationFunction} when its 'help' button is pressed by the user.
	 */
	public Class<? extends Presentation> helpPresentationClass();
}
