/**
 * 
 */
package be.ASPL.presentationlayer;

import java.util.HashMap;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

import be.SIRAPRISE.util.Localizer;

/**
 * @author Erwin
 * 
 */
class I18N implements Localizer {

	/**
	 * 
	 */
	private static final Localizer instance = new I18N();

	/**
	 * 
	 */
	private static final HashMap<String, ResourceBundle> resourceBundleMap = new HashMap<String, ResourceBundle>();

	/**
	 * @return
	 */
	static Localizer getInstance ( ) {
		return instance;
	}

	/**
	 * @param locale
	 * @param key
	 * @return
	 */
	static String getString (Locale locale, String key) {
		ResourceBundle resourceBundle;
		if (resourceBundleMap.containsKey(locale.getLanguage())) {
			resourceBundle = resourceBundleMap.get(locale.getLanguage());
		} else {
			resourceBundle = ResourceBundle.getBundle(I18N.class.getName(), new Locale(locale.getLanguage()));
			resourceBundleMap.put(locale.getLanguage(), resourceBundle);
		}

		try {
			return resourceBundle.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}

	/**
	 * @param key
	 * @return
	 */
	static String getString (String key) {
		return getString(Locale.getDefault(), key);
	}

	/**
	 * Prevent instantiation
	 */
	private I18N ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.util.Localizer#getString(java.lang.String, java.util.Locale)
	 */
	@Override
	public String getString (String key, Locale locale) {
		return getString(locale, key);
	}
}
