package be.ASPL.presentationlayer;

import java.util.HashMap;
import java.util.LinkedList;

/**
 * @author Erwin
 */
public class ListValue implements PresentationValue {

	/**
	 * Comment for <code>listName</code>
	 */
	private String listName;

	/**
	 * Comment for <code>rowList</code>
	 */
	private LinkedList<HashMap<String, PresentationValue>> rowList = new LinkedList<HashMap<String, PresentationValue>>();

	/**
	 * @param listName
	 *            -
	 */
	public ListValue (String listName) {
		this.listName = listName;
	}

	/**
	 * @param m
	 *            a Map of column names to PresentationValues to be appended to the list as a row
	 */
	public void append (HashMap<String, PresentationValue> m) {
		rowList.addLast(m);
	}

	/**
	 * @return the list name
	 */
	public String getListName ( ) {
		return listName;
	}

	/**
	 * @return the list
	 */
	public LinkedList<HashMap<String, PresentationValue>> getRowList ( ) {
		return rowList;
	}

	public String toString ( ) {
		return rowList.toString();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.WaarValue#toWAARString(be.ASPL.presentationlayer.UserData)
	 */
	@Override
	public String toASPLString (UserData userData) {
		return rowList.toString();
	}
}
