/*
 * Created on 24-mrt-05
 */
package be.ASPL.presentationlayer;

import java.util.HashMap;

/**
 * The PresentationArchitectureFieldMap is the map of Architecture field names and their corresponding ValueGetters
 * 
 * @author Erwin
 */
final class PresentationArchitectureFieldMap extends HashMap<String, ArchitectureValueGetter> {

	/**
	 * The instance of the map
	 */
	private static PresentationArchitectureFieldMap instance = new PresentationArchitectureFieldMap();

	/**
	 * 
	 */
	private static final long serialVersionUID = -8313999835008551056L;

	/**
	 * Gets the instance
	 * 
	 * @return the instance
	 */
	static PresentationArchitectureFieldMap getInstance ( ) {
		return instance;
	}

	/**
	 * Creates the Architecture field map
	 */
	private PresentationArchitectureFieldMap ( ) {
		put("CharSet", ArchitectureValueGetterForCharSet.getInstance()); //$NON-NLS-1$
		put("Date", ArchitectureValueGetterForDate.getInstance()); //$NON-NLS-1$
		put("Time", ArchitectureValueGetterForTime.getInstance()); //$NON-NLS-1$
		put("NextRowStyleClassName", ArchitectureValueGetterForNextRowStyleClassName.getInstance()); //$NON-NLS-1$
		put("NextRowStyleClassName1", ArchitectureValueGetterForNextRowStyleClassName1.getInstance()); //$NON-NLS-1$
		put("NextRowStyleClassName2", ArchitectureValueGetterForNextRowStyleClassName2.getInstance()); //$NON-NLS-1$
		put("NextRowStyleClassName3", ArchitectureValueGetterForNextRowStyleClassName3.getInstance()); //$NON-NLS-1$
		put("Message", ArchitectureValueGetterForMessage.getInstance()); //$NON-NLS-1$
		put("ApplicationName", ArchitectureValueGetterForApplicationName.getInstance()); //$NON-NLS-1$
		put("ServerInfo", ArchitectureValueGetterForServerInfo.getInstance()); //$NON-NLS-1$
		put("FormEncodingType", ArchitectureValueGetterForFormEncodingType.getInstance()); //$NON-NLS-1$
		put("PresentationName", ArchitectureValueGetterForPresentationName.getInstance()); //$NON-NLS-1$
		put("PresentationFunction", ArchitectureValueGetterForPresentationFunction.getInstance()); //$NON-NLS-1$
		put("HelpButton", ArchitectureValueGetterForHelpButton.getInstance()); //$NON-NLS-1$
		put("Userid", ArchitectureValueGetterForUserid.getInstance()); //$NON-NLS-1$
		put("USERSESSIONID", ArchitectureValueGetterForUSERSESSIONID.getInstance()); //$NON-NLS-1$
		put("USERSESSIONTOKEN", ArchitectureValueGetterForUSERSESSIONTOKEN.getInstance()); //$NON-NLS-1$
	}
}
