/**
 * 
 */
package be.SIRAPRISE.birdwatcher;

import java.util.Date;

import be.SIRAPRISE.client.jsba.*;
import be.SIRAPRISE.typeimplementations.*;

/**
 * @author Erwin
 * 
 */
@Relvars(relvarNames = { RELVARNAMES.SPOTS, RELVARNAMES.GSPOTS })
public final class Spot extends AbstractUpdatableDBObject {

	/**
	 * 
	 */
	private char gender;

	/**
	 * 
	 */
	private Spot preUpdateState;

	/**
	 * 
	 */
	private String speciesName;

	/**
	 * 
	 */
	private int spotCount;

	/**
	 * 
	 */
	private Date walkDate;

	/**
	 * Creates the Spot
	 */
	public Spot ( ) {
		this(null, "", -1, ' '); //$NON-NLS-1$
	}

	/**
	 * Creates the Spot
	 * 
	 * @param walkDate
	 *            -
	 * @param speciesName
	 *            -
	 * @param spotCount
	 *            -
	 * @param gender
	 *            -
	 */
	public Spot (Date walkDate, String speciesName, int spotCount, char gender) {
		this.walkDate = walkDate;
		this.speciesName = speciesName;
		this.spotCount = spotCount;
		this.gender = gender;
	}

	/**
	 * Gets gender
	 * 
	 * @return gender.
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = ATTRIBUTENAMES.GENDER, requiresEscaping = false, typeName = TYPENAMES.CHAR) }, relvarNames = { RELVARNAMES.GSPOTS })
	public final char getGender ( ) {
		return gender;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#getPreUpdateState()
	 */
	@Override
	public UpdatableDBObject getPreUpdateState ( ) {
		return preUpdateState;
	}

	/**
	 * Gets speciesName
	 * 
	 * @return speciesName.
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = ATTRIBUTENAMES.SPECIESNAME, requiresEscaping = true, typeName = TYPENAMES.STRING) }, relvarNames = { RELVARNAMES.SPOTS, RELVARNAMES.GSPOTS })
	public final String getSpeciesName ( ) {
		return speciesName;
	}

	/**
	 * Gets spotCount
	 * 
	 * @return spotCount.
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = ATTRIBUTENAMES.SPOTCOUNT, requiresEscaping = false, typeName = TYPENAMES.INT) }, relvarNames = { RELVARNAMES.SPOTS, RELVARNAMES.GSPOTS })
	public final int getSpotCount ( ) {
		return spotCount;
	}

	/**
	 * Gets walkDate
	 * 
	 * @return walkDate.
	 */
	@GetterMethod(attributeDefs = { @AttributeDef(attributeName = ATTRIBUTENAMES.WALKDATE, requiresEscaping = false, typeName = TYPENAMES.DATE) }, relvarNames = { RELVARNAMES.SPOTS, RELVARNAMES.GSPOTS })
	public final Date getWalkDate ( ) {
		return walkDate;
	}

	/**
	 * Sets gender
	 * 
	 * @param gender
	 *            The gender to set.
	 */
	public final void setGender (char gender) {
		this.gender = gender;
	}

	/**
	 * Sets gender
	 * 
	 * @param gender
	 *            The gender to set.
	 */
	@AttributeDef(attributeName = ATTRIBUTENAMES.GENDER, requiresEscaping = false, typeName = TYPENAMES.CHAR)
	public void setGender (ValueBuffer gender) {
		this.gender = DbmsCharImplementation.getJavaChar(gender);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.client.UpdatableDBObject#setPreUpdateState()
	 */
	@Override
	public void setPreUpdateState ( ) {
		this.preUpdateState = new Spot(walkDate, speciesName, spotCount, gender);
	}

	/**
	 * Sets speciesName
	 * 
	 * @param speciesName
	 *            The speciesName to set.
	 */
	public final void setSpeciesName (String speciesName) {
		this.speciesName = speciesName;
	}

	/**
	 * Sets speciesName
	 * 
	 * @param speciesName
	 *            The speciesName to set.
	 */
	@AttributeDef(attributeName = ATTRIBUTENAMES.SPECIESNAME, requiresEscaping = true, typeName = TYPENAMES.STRING)
	public void setSpeciesName (ValueBuffer speciesName) {
		this.speciesName = DbmsStringImplementation.getJavaString(speciesName);
	}

	/**
	 * Sets spotCount
	 * 
	 * @param spotCount
	 *            The spotCount to set.
	 */
	public final void setSpotCount (int spotCount) {
		this.spotCount = spotCount;
	}

	/**
	 * Sets spotCount
	 * 
	 * @param spotCount
	 *            The spotCount to set.
	 */
	@AttributeDef(attributeName = ATTRIBUTENAMES.SPOTCOUNT, requiresEscaping = false, typeName = TYPENAMES.INT)
	public void setSpotCount (ValueBuffer spotCount) {
		this.spotCount = DbmsIntImplementation.getJavaInt(spotCount);
	}

	/**
	 * Sets walkDate
	 * 
	 * @param walkDate
	 *            The walkDate to set.
	 */
	public final void setWalkDate (Date walkDate) {
		this.walkDate = walkDate;
	}

	/**
	 * Sets walkDate
	 * 
	 * @param walkDate
	 *            The walkDate to set.
	 */
	@AttributeDef(attributeName = ATTRIBUTENAMES.WALKDATE, requiresEscaping = false, typeName = TYPENAMES.DATE)
	public void setWalkDate (ValueBuffer walkDate) {
		this.walkDate = DbmsDateImplementation.getJavaDate(walkDate);
	}
}
