package be.SIRAPRISE.birdwatcher;

import java.util.Locale;

import be.ASPL.presentationlayer.ASPLException;
import be.ASPL.presentationlayer.ASPLListFactory;
import be.ASPL.presentationlayer.InitialPresentation;
import be.ASPL.presentationlayer.OnLinePresentationFunctionCharacteristics;

/**
 * The function to produce an overview of defined attributes
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = SpotsOverviewPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = false, descriptionLocalizationKey = "SpotsOverview.Text")
public class SpotsOverview extends BWSpotsFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doInitialLogic()
	 */
	public void doInitialLogic ( ) {
		setDefaultLanguageFromUserContext();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		Locale locale = getUserLocale();
		setPresentationValue("SPOTSLIST", ASPLListFactory.getASPLListValue(getPresentation().getPresentationField("SPOTSLIST"), getMatchingSpots(), getUserData(), locale)); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		doPresentationLogic();
	}
}