/**
 * 
 */
package be.SIRAPRISE.birdwatcher;

import be.ASPL.presentationlayer.*;
import be.SIRAPRISE.client.ConnectionClosedException;
import be.SIRAPRISE.client.DBConnection;
import be.SIRAPRISE.client.TransactionMode;
import be.SIRAPRISE.client.jsba.DmlCommand;
import be.SIRAPRISE.messages.ErrorMessageException;

/**
 * @author Erwin
 * 
 */
@InitialPresentation(initialPresentationClass = WalkPresentation.class)
public final class WalksCreate extends BWWalksFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.OnLinePresentationFunction#doInitialLogic()
	 */
	@Override
	public void doInitialLogic ( ) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.OnLinePresentationFunction#doPresentationLogic()
	 */
	@Override
	public void doPresentationLogic ( ) throws ASPLException {
		
		try (DBConnection dbc = getDBConnection();) {
			DateValue walkDate = (DateValue) getPresentationValue(ATTRIBUTENAMES.WALKDATE);
			DmlCommand.execDmlCommandAndEndTransaction(dbc.startTransaction(getUserData().getUserID(), true, "", new byte[] {}, TransactionMode.UPDATE), new Walk(walkDate.getDate()).dbAddCommand(RELVARNAMES.WALK)); //$NON-NLS-1$
			saveInSessionContext(ATTRIBUTENAMES.WALKDATE, walkDate);
		} catch (ConnectionClosedException e) {
			log(e);
			throw new ASPLApplicationException(e);
		} catch (ErrorMessageException e) {
			log(e);
			throw new ASPLApplicationException(e);
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.presentationlayer.OnLinePresentationFunction#getPresentationFunctionDescription(java.lang.String)
	 */
	@Override
	public String getPresentationFunctionDescription () {
		return I18N.getString(getUserLocale(), "WalksCreate.Text"); //$NON-NLS-1$
	}

}
