package be.SIRAPRISE.birdwatcher;

import java.util.Locale;

import be.ASPL.presentationlayer.ASPLException;
import be.ASPL.presentationlayer.ASPLListFactory;
import be.ASPL.presentationlayer.InitialPresentation;
import be.ASPL.presentationlayer.OnLinePresentationFunctionCharacteristics;

/**
 * The function to produce an overview of defined attributes
 * 
 * @author Erwin
 */
@InitialPresentation(initialPresentationClass = WalksOverviewPresentation.class)
@OnLinePresentationFunctionCharacteristics(leaveFunctionOnExit = false, descriptionLocalizationKey = "WalksOverview.Text")
public class WalksOverview extends BWWalksFunction {

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doInitialLogic()
	 */
	public void doInitialLogic ( ) {
		setDefaultLanguageFromUserContext();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doPresentationLogic()
	 */
	public void doPresentationLogic ( ) throws ASPLException {
		Locale locale = getUserLocale();
		setPresentationValue("WALKSLIST", ASPLListFactory.getASPLListValue(getPresentation().getPresentationField("WALKSLIST"), getMatchingWalks(), getUserData(), locale)); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.ASPL.OnLinePresentationFunction#doResumeLogic()
	 */
	public void doResumeLogic ( ) throws ASPLException {
		//		if (getPresentationValue(BWDBATTRIBUTENAMES.SPECIESNAME) != null || getPresentationValue("FROMDATE") != null || getPresentationValue("TODATE") != null) { //$NON-NLS-1$//$NON-NLS-2$
		doPresentationLogic();
		// }
	}
}