/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.util.MyMessageFormat;

/**
 * ExceptionClassMismatch
 * 
 * @author erwin
 * 
 * 
 */
final class ExceptionClassMismatch extends TestResultDetails {

	/**
	 * 
	 */
	private String expectedExceptionClassName;

	/**
	 * 
	 */
	private String obtainedExceptionClassName;

	/**
	 * Creates the ExceptionClassMismatch
	 * 
	 * @param expectedExceptionClassName
	 * @param obtainedExceptionClassName
	 */
	ExceptionClassMismatch (String expectedExceptionClassName, String obtainedExceptionClassName) {
		this.expectedExceptionClassName = expectedExceptionClassName;
		this.obtainedExceptionClassName = obtainedExceptionClassName;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Exception class mismatch : expected {0} gotten {1}", new String[] { expectedExceptionClassName, obtainedExceptionClassName }); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
