/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.messages.ErrorMessageException;
import be.SIRAPRISE.util.MyMessageFormat;

/**
 * UnexpectedExceptionDetails
 * 
 * @author erwin
 */
final class UnexpectedExceptionDetails extends TestResultDetails {

	/**
	 * 
	 */
	private Exception e;

	/**
	 * 
	 */
	private String expectedRelationValue;

	/**
	 * Creates the UnexpectedExceptionDetails
	 * 
	 * @param e
	 */
	UnexpectedExceptionDetails (Exception e) {
		this.e = e;
	}

	/**
	 * Creates the UnexpectedExceptionDetails
	 * 
	 * @param expectedRelationValue
	 * @param e
	 */
	UnexpectedExceptionDetails (String expectedRelationValue, Exception e) {
		this(e);
		this.expectedRelationValue = expectedRelationValue;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Expected relation {0} \nbut got exception {1}", new String[] { expectedRelationValue, e.getClass().getName() + ' ' + (e instanceof ErrorMessageException ? (((ErrorMessageException) e).getServerErrorMessage().getErrorClass() + ':' + ((ErrorMessageException) e).getServerErrorMessage().getErrorNumber()) : "") }); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		final LogRecord logRecord = new LogRecord(Level.WARNING, message());
		logRecord.setThrown(e);
		return logRecord;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
		e.printStackTrace(out);
	}

}
