/**
 * 
 */
package be.SIRAPRISE.tests.officialtestset;

import java.io.PrintStream;
import java.util.logging.Level;
import java.util.logging.LogRecord;

import be.SIRAPRISE.typeimplementations.Relation;
import be.SIRAPRISE.util.MyMessageFormat;

/**
 * UnexpectedRelation
 * 
 * @author erwin 
 * 
 */
final class UnexpectedRelation extends TestResultDetails {

	/**
	 * 
	 */
	private String expectedExceptionDetails;

	/**
	 * 
	 */
	private Relation result;

	/**
	 * Creates the UnexpectedRelation
	 * 
	 * @param expectedExceptionDetails
	 * @param result
	 */
	UnexpectedRelation (String expectedExceptionDetails, Relation result) {
		this.expectedExceptionDetails = expectedExceptionDetails;
		this.result = result;
	}

	/**
	 * @return
	 */
	private String message ( ) {
		return MyMessageFormat.format("Expected exception {0} but got actual result {1}", new String[] { expectedExceptionDetails, result.printBodyWithoutBodyHeaderWithoutTypeNames() }); //$NON-NLS-1$
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#getLogRecord()
	 */
	@Override
	LogRecord getLogRecord ( ) {
		return new LogRecord(Level.WARNING, message());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see be.SIRAPRISE.tests.officialtestset.TestResultDetails#log(java.io.PrintStream)
	 */
	@Override
	void log (PrintStream out) {
		out.println(message());
	}

}
